local _, EIA = ...
local FailNotes = EIA:NewModule("FailNotes")

local AceGUI3 = LibStub("AceGUI-3.0")

WindsFrames = {}

PopupAfterWipeFrame = {}

-- ********************
-- *** Data ****
-- ********************
local Winds = {}

-- ****************************
-- *** Localized spell name ***
-- ****************************
local AURA_EYE_OF_ANZU, _, AURA_EYE_OF_ANZU_ICON = GetSpellInfo(EIA.AuraEyeOfAnzuSpellID)
local AURA_PHANTASMAL_WINDS, _, AURA_PHANTASMAL_WINDS_ICON = GetSpellInfo(EIA.AuraPhantasmalWindsSpellID)


local defaults = {
  profile = {
    enabled = true
  }
}

function FailNotes:OnInitialize()
  self.db = EIA.db:GetNamespace("FailNotes", true) or EIA.db:RegisterNamespace("FailNotes", defaults)
  --self:CreateWindsFrame()
  --self:CreatePopupAfterFrame()
end

function FailNotes:OnEnable()

end

function FailNotes:OnDisable()

end

function FailNotes:CreateWindsFrame()
  local scrollingTable = LibStub("ScrollingTable");
  local scrollCols = {
    { ["name"] = "Iskar HP (%)", ["width"] = 50, ["align"] = "CENTER"},
    { ["name"] = "Player", ["width"] = 100 },
    { ["name"] = "Event info", ["width"] = 200, ["align"] = "CENTER"},
    { ["name"] = "Time with Eye (s)", ["width"] = 50 },
    { ["name"] = "Received from", ["width"] = 100},
    { ["name"] = "Sent to", ["width"] = 100},
  }

  local table = scrollingTable:CreateST(scrollCols);

  local data = {
    { 10.1, "Skamer","Skamer sent the eye of Anzu to Ellendra", 5.3, "Divi", "Ellendra"},
    { 8.3, "Fufu", "Fufu has died because nobody wants to send him the Eye", 0, "", ""},
    { 7.4, "Ellendra", "Ellendra sent the eye of Anzu to Divi", 2.4, "Skamer", "Divi"},
  }


  local row1 = {
    ["cols"] = {
      ["value"] = 0,
      {["value"]          = 10.1},
      {["value"]          = "Skamer"},
      {["value"]          = "Skamer sent the eye of Anzu to Ellendra"},
      {["value"]          = 5.3},
      {["value"]          = "Divi"},
      {["value"]          = "Ellendra"},
      ["args"] = nil,
      ["colorargs"] = nil,
      ["DoCellUpdate"] = nil,
    },
    ["color"] = {
      ["r"] = 1.0,
      ["g"] = 0.0,
      ["b"] = 0.0,
      ["a"] = 1.0
    },
    ["colorargs"] = nil,
    ["DoCellUpdate"] = nil,

  }

  local data1 = {
    row1,
  }

  table:SetData(data1)
  table:Hide()
end

function FailNotes:CreatePopupAfterFrame()
  local popup = AceGUI3:Create("Popup")
  popup:SetTitle("Epsi Iskar Assist - Failnotes")
  popup:SetWidth(410)
  popup:SetHeight(150)

  local btnGroup = AceGUI3:Create("SimpleGroup")
  btnGroup:SetFullWidth(true)
  btnGroup:SetLayout("Flow")

  local btnWakeUp = AceGUI3:Create("Button")
  btnWakeUp:SetWidth(250)
  btnWakeUp:SetText("Yes, i'm going to wake him up")

  local btnLater = AceGUI3:Create("Button")
  btnLater:SetWidth(75)
  btnLater:SetText("Later")

  btnGroup:AddChild(btnWakeUp)
  btnGroup:AddChild(btnLater)

  local text = AceGUI3:Create("Label")
  text:SetFullWidth(true)
  text:SetFont(GameFontHighlightSmall:GetFont(), 12, nil)
  -- it seems that someone has died by the fanstamal winds because the one hasn't received the Eye in time. Do you see who was sleeping with Eye ?
  text:SetText("It seems that someone has died by the phantasmal winds because the one hasn't received the eye of Anzu at time. Would you know who was sleeping with the eye of Anzu ?")

  local hrLine = AceGUI3:Create("Heading")
  hrLine:SetFullWidth(true)

  local noMoreShowThisPopup = AceGUI3:Create("CheckBox")
  noMoreShowThisPopup:SetValue(false)
  noMoreShowThisPopup:SetFullWidth(true)
  noMoreShowThisPopup:SetLabel("Don't show this popup again.")

  popup:AddChild(text)
  popup:AddChild(btnGroup)
  popup:AddChild(hrLine)
  popup:AddChild(noMoreShowThisPopup)

end

--[[
local logs = {}

logs[timestamp].

Log = {
  players[GUID] = {name, class, role)
  winds[index] = { players, playersDeath, startTimestamp, stopTimestamps}
  eyeOfAnzuHolders[index] = { player, timestampReceived, timestampSent}
}


Log = {
  players[GUID] = { name, class, role}
  winds[index] = { players, playersDeath, timestamp,

}
events[timestamp] = {
timestamp,
type,
source,
target,
}

}
}

Encounter.winds[1] = {
  timestamp = timestamp
  players =

}

FailNotes:NewEncounteLog()
FailNotes:AddPlayerInfo(guid, name, class, role)
FailNotes:NewWindsLog(timestamp)
FailNotes:AddWindPlayer(guid)
FailNotes:StopWindsLog(timestamp)

Log.winds[1] = {
startTimestamp, stopTimestamps,
startEyeOfAnzuIndex, stopEyeofAnzuIndex,
players = {guid, iskarHP}
playersDeath =  {guid, deathTimestamp, indexEyeOfAnzu, iskarHP}
}

--]]

function FailNotes:StartEncounterLog()

end

function FailNotes:StopEncounterLog()

end

function FailNotes:SetEyeOfAnzu(guid, timestamp)

end

function FailNotes:AddWind(guid, timestamp)

end

-- **********************
-- *** Event Handlers ***
-- **********************
function FailNotes:HandleCombatLog(event, timestamp, message, _, sourceGUID, sourceName, _, _, destGUID, destName, destFlags, destFlags2, ...)
	local isPlayer = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
  local isFriendly = bit.band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0
	 local isInRaid = bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_RAID + COMBATLOG_OBJECT_AFFILIATION_PARTY + COMBATLOG_OBJECT_AFFILIATION_MINE) > 0

    -- check if it's a friendly player who is in the raid
    if isPlayer and isFriendly and isInRaid then
		--local destName, _ = strsplit("-", destName)
		if message == "SPELL_AURA_APPLIED" or message  == "SPELL_AURA_REFRESH" or message == "SPELL_AURA_APPLIED_DOSE" then
			local spellID, spellName = ...

			if spellName == AURA_EYE_OF_ANZU then -- or spellID == 41635 test
				self:SetEyeOfAnzu(destGUID, timestamp)
			elseif spellName == AURA_PHANTASMAL_WINDS then -- spellID == 17
				self:AddWind(destGUID, timestamp)
			end
		elseif message == "SPELL_AURA_REMOVED" or message == "SPELL_AURA_REMOVED_DOSE" then
			local spellID, spellName = ...

			if spellName == AURA_EYE_OF_ANZU or spellID == 41635 then -- or spellID == 41635 test pom
				self:SetEyeOfAnzu(destGUID, timestamp)
			elseif spellName == AURA_PHANTASMAL_WINDS then
				self:RemoveWind(destGUID, timestamp)
      end
		end

	elseif message == "UNIT_DIED" then
			--if tonumber(GetNpcID(destGUID)) == IskarID then
				--needHide = true
			--end
	end
end

function FailNotes:GetOptions()
  FailNotes.options = {
        type = "group",
        name = "Fail Notes (in development)",
        order = 3,
        args = {

        }
  }
  return  FailNotes.options
end
